#ifndef __MODEL_DOCUMENT__
#define __MODEL_DOCUMENT__

#include <deque>
#include "Phrase.h"
using namespace std;

class Document;
typedef deque <Document*>	Document_dq_t;


class Document
{
	// nt          : number of tokens		
	// token_index : token types			
	// words       : token counts			
	// zt          : token topic			
	// At          : token topic source		
	// zw          : type topic counts		
	
	// phrases     : phrase annotations		
	// zy          : phrase topic [phrase.h]
	// zl          : topic annotations		
	
	// total_words : total token count		
	
	public:
		static Document_dq_t	sdq_Documents;
		static unsigned long	sul_TotalTokenCount;
		static unsigned int		sui_Types;
		static unsigned int		sui_UniquePhrases;

		unsigned int			ui_DocumentTokens;
		unsigned int*			pui_TokenIndex;
		unsigned int*			pui_TokenType;
		unsigned int*			pui_TokenTopic;
		char*					pc_TokenTopicSource;
		unsigned long*			pul_PhraseTopicTokenCounts;

		unsigned int			ui_DocumentPhrases;
		unsigned int*			pui_PhraseAnnotation;
		Phrase**				pp_PhraseAnnotation;
		double*					pd_TopicAnnotation;

		double*					pd_ThetaD;
		double					d_R;
		bool					b_TestDocument;
		double*					pd_SumThetaD;


		Document (void);
		~Document (void);

		static bool Load (void);
		static bool LoadTraining (void);
		static bool LoadTestWithAnnotations (void);
		static bool LoadTestWithoutAnnotations (void);
		static void InitParameters (void);
		static void Clear (void);
		static void SaveTestDocumentTopics (void);
};


#endif
