#include <iostream>
#include <nlp_config.h>
#include <nlp_macros.h>
#include "Phrase.h"
#include "Document.h"
#include "Model.h"


int main (int argc, const char* argv [])
{
	Config::SetCommandLine (argc, argv);

	Model model;

	cout << "Loading phrases ..." << endl;
	if (false == Phrase::Load ())
		return 1;
	cout << "Loading documents ..." << endl;
	if (false == Document::Load ())
		return 1;

	cout << "Initializing model parameters to random values ..." << endl;
	Phrase::InitParameters ();
	Document::InitParameters ();
	model.Init ();

	cout << "Estimating model parameters ..." << endl;
	model.Sample ();

	cout << "Saving test document topics ..." << endl;
	Document::SaveTestDocumentTopics ();

	return 0;
}
