#include "nlp_gslext.h"
#include <iostream>


// ------------------------------------------------------------
std::ostream& operator<< (std::ostream& _rStream, gsl_vector* _pVector)
{
	if (0 == _pVector->size)
		return _rStream;

	_rStream << gsl_vector_get (_pVector, 0);
	for (size_t i = 1; i < _pVector->size; ++ i)
		_rStream << ',' << gsl_vector_get (_pVector, i);

	return _rStream;
}


// ------------------------------------------------------------
std::ostream& operator<< (std::ostream& _rStream, gsl_matrix* _pMatrix)
{
	if ((0 == _pMatrix->size1) || (0 == _pMatrix->size2))
		return _rStream;

	_rStream << gsl_matrix_get (_pMatrix, 0, 0);
	for (size_t c = 1; c < _pMatrix->size2; ++c)
		_rStream << ',' << gsl_matrix_get (_pMatrix, 0, c);
	for (size_t r = 1; r < _pMatrix->size1; ++ r)
	{
		_rStream << endl;
		_rStream << gsl_matrix_get (_pMatrix, r, 0);
		for (size_t c = 1; c < _pMatrix->size2; ++c)
			_rStream << ',' << gsl_matrix_get (_pMatrix, r, c);
	}
	return _rStream;
}


